#include <stdio.h>

int hanoi(int, char, char, char);

int main() {
    int n;
    printf("How many discs are there to move? ");
    scanf("%d", &n);

    printf("Sequence of moves required: \n");
    int moves = hanoi(n, 'S', 'D', 'T');

    printf("\nA total of %d moves in all.\n", moves);
    return 0;
}

int hanoi (int discs, char src, char dest, char temp)
{
    if (discs == 1)
    {
        printf("Move 1 disc from %c to %c\n", src, dest);
        return 1;
    }
    else
    {
        int total = 0;
        total += hanoi(discs-1, src, temp, dest);
        printf("Move 1 disc from %c to %c\n", src, dest);
        total += hanoi(discs-1, temp, dest, src);
        return total + 1;
    }
}