#include <stdio.h>

struct fighter
{
    char * name;
    int damage;
    int hp;
};

void heal (struct fighter patient);

void attack (struct fighter * attacker,
             struct fighter * defender);

int main()
{
    struct fighter first = {"Beowulf", 5, 25};
    struct fighter second = {"Sigmar", 3, 35};

    printf("%s's health: %d", first.name, first.hp);

    heal(first);

    printf("%s's health: %d", first.name, first.hp);

    while (first.hp > 0 && second.hp > 0) {
        printf("%s: %d hp\t%s: %d hp\n", first.name,
               first.hp, second.name, second.hp);

        printf("%s attacks!\n", first.name);
        attack(&first, &second);

        if (second.hp > 0) {
            printf("%s retaliates!\n", second.name);
            attack(&second, &first);
        }
    }

    if (first.hp > 0)
    {
        printf("%s is victorious!", first.name);
    }
    else
    {
        printf("%s is victorious!", second.name);
    }
    return 0;
}

void heal (struct fighter f)
{
    f.hp += 5;
    printf("%s's hit points are now %d", f.name, f.hp);
}

void attack (struct fighter * a, struct fighter * d)
{
    d->hp -= a->damage;
}
