#include <stdio.h>

long long fact(long long n);

int fib(int n);

int main()
{
    int fValue;

    printf("Enter a value to calculate a factorial for: ");
    scanf("%d", &fValue);

    printf("%d! = %lld", fValue, fact(fValue));

    int fibValue;
    printf("Enter the Fibonacci term to compute: ");
    scanf("%d", &fibValue);

    printf("The %dth term is %d\n", fibValue, fib(fibValue));

    return 0;
}

long long fact (long long n) /* compute factorial recursively */
{
    printf("Calling fact(%lld)...\n", n);

    if (n < 2) /* base case */
    {
        return 1;
    }
    else /* recursive case */
    {
        return n * fact(n-1);
    }
}

int fib(int n)
{
    printf("Calling fib(%d)...\n", n);
    if (n < 2)
    {
        return n; /* base case */
    }
    else
    {
        return fib(n - 1) + fib(n - 2);
    }
}
